.TH KILLREQ 1 "AMIGA Programmer's Manual" "Copyright Eddy Carroll 1989"
.SH NAME
killreq - disables Intuition's AutoRequest() function
.SH SYNOPSIS
killreq [disable | enable]
.SH DESCRIPTION
Killreq is a freely distributable
utility which stops Intuition from displaying AutoRequesters.
Instead, any program which tries to display an AutoRequester will be fooled
into thinking the user selected the CANCEL option. In particular, AmigaDOS
requesters will not be displayed. These include "Please insert volume xyzzy:",
"Disk Full" and "Volume xyzzy: has a Read/Write error".

Similar programs (such as NoReq) already exist, but these only affect
requesters connected with a particular CLI window. KillReq will disable
requesters on a systemwide basis. This is particularly useful if you
use your Amiga remotely a lot, since some programs (BBS-PC springs to mind)
can generate AutoRequesters even when they have been disabled.

Invoking killreq with no parameters displays a brief usage method. Otherwise,
you should specify either `disable' or `enable' (only the first letter is
actually checked). `disable' will stop Intuition from displaying
AutoRequesters and `enable' will allow AutoRequesters to be displayed
again.

.SH OPERATION
Killreq tries to be as friendly to the operating system as possible. It
SetFunction()'s the AutoRequest() function in Intuition's library
to point to a stub routine which simply returns FALSE. If another program
tries to SetFunction() AutoRequest(), killreq will still allow itself to be
disabled without pulling the rug out from under the second program. It
tries to guarantee that the system is in a "safe" state at all times.

In fact, a program that does basically the same thing as killreq could be
written in around 50 bytes of machine-code (or less), but since this is
such a simple application of SetFunction(), it seemed worth the extra code
to do it "properly" as an example for more sophisticated usages.
.SH AUTHOR
Eddy Carroll
.br
EMAIL: ecarroll@@vax1.tcd.ie
