#ifndef DATATYPES_BINARY_H
#define DATATYPES_BINARY_H
/*
** $VER: binaryclass.h 39.3 (26.12.94)
**
** by
**
** Stefan Ruppert , Windthorststrae 5 , 65439 Flrsheim , GERMANY
**
** (C) Copyright 1994
** All Rights Reserved !
**
*/

/* ------------------------------- includes ------------------------------- */

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif

#ifndef DATATYPES_DATATYPESCLASS_H
#include <datatypes/datatypesclass.h>
#endif

/* ------------------------------ class name ------------------------------ */

#define BINARYDTCLASS              "binary.datatype"

/* ------------------------------ attributes ------------------------------ */

#define BDTA_Dummy         (DTA_Dummy + 0x8000)

#define BDTA_Buffer        (BDTA_Dummy + 0x00)
                        /* (UBYTE *) pointer to the real data
                         * Applicability is (ISG)
                         */

#define BDTA_BufferLen     (BDTA_Dummy + 0x01)
                        /* (ULONG) length of the buffer
                         * Applicability is (ISG)
                         */

#define BDTA_BytesPerLine  (BDTA_Dummy + 0x02)
                        /* (UWORD) number of words in a line
                         * Applicability is (ISGNU)
                         */

#define BDTA_DisplayHex    (BDTA_Dummy + 0x03)
                        /* (UWORD) displayhex type see BDTDH_#? value
                         * Applicability is (ISGNU)
                         */

#define BDTA_ShowASCII     (BDTA_Dummy + 0x04)
                        /* (BOOL) display at the end of the line the ASCII
                         * equivalent !
                         * Applicability is (ISGNU)
                         */

#define BDTA_DisplayWrap   (BDTA_Dummy + 0x05)
                        /* (BOOL) if TRUE use only the view width for
                         * rendering. Otherwise the width is calculated with the
                         * current settings.
                         * Applicability is (ISGNU)
                         */

#define BDTDH_NONE      0     /* show now hex values */
#define BDTDH_BYTE      1     /* show byte hex values */
#define BDTDH_WORD      2     /* show word hex values */
#define BDTDH_LONG      3     /* show long word hex values */

#endif /* !DATATYPES_BINARY_H */

