/***********************
    Send_At.rexx
    $VER: 1.0 by Michael Watzl

    ENGLISH:
    --------

    Send_at.rexx <time> <commandstring>

    This script waits untill <time> and IR_SENDs commandstring to
    protname (which can be edited some lines down).

    Example: Switch off tv set at 3:00

    1> rx send_at "3:00" "IR_SEND '$POWER'"

    Assuming that the tvset.irm is running and the gadget 'POWER'
    exists and is learned

    DEUTSCH:
    --------

    Send_at.rexx <zeit> <kommando>

    Dieses Script wartet bis um <zeit> Uhr und IR_SENDet dann
    <kommando> zu dem ARexxport, der am anfang des Scripts steht
    und dort entsprechend gendert werden mu.

    Beispiel:  Der Fernseher soll um 3:00 abgeschalten werden.

    1> rx send_at "3:00" "IR_SEND '$POWER'"

    Wenn tvset.irm luft und das Gadget "POWER" existiert und
    eingelernt ist...
**************************/

address  "tvset_rexx" /* Hier mu der korrekte Namen des Projektes
                         angegeben werden, Gro- und Kleinschreibung!*/
                      /* Here you must edit the address: Type the
                         correct (case sensitive) port name */


arg time commandstring

/* fhrende Leerzeichen entfernen */
commandstring = strip( commandstring , "L" )

/* mit dem Shellkommando Wait wird bis zur entsprechenden Uhrzeit gewartet */
say "Warte bis um "time " Uhr"
address command "wait until "time


/* Bei Leerzeichen im Commandostring werden zustzliche Anfhrungszeichen
   bentigt! */
"IR_SEND $"commandstring

exit
