/* wbwm.h */

#define FNUM 11
#define NUMBEROFFUNCTIONS FNUM

#define ASM __asm __saveds
#define REG(x) register __## x int x

#define ARGS \
REG(d0), REG(d1), REG(d2), REG(d3), REG(d4), REG(d5), REG(d6), REG(d7),\
REG(a0), REG(a1), REG(a2), REG(a3), REG(a6)

#define ALIST d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a6

#define DEC_LVO(name)	extern LVO## name
#define DEC_ASM(name)	extern name## Stub
#define DEC_OLD(name)	LONG (*ASM name## O) (ARGS)
#define DEC_NEW(name)	LONG ASM name## R (ARGS)
#define DECLARE(name)	DEC_OLD(name); DEC_NEW(name); DEC_LVO(name); DEC_ASM(name);

#define FUNCTIONS \
{ &LVOCloseWindow, (struct Library *) & IntuitionBase, &CloseWindowO, &CloseWindowStub },\
{ &LVOMoveWindow, (struct Library *) & IntuitionBase, &MoveWindowO, &MoveWindowStub },\
{ &LVOOpenWindow, (struct Library *) & IntuitionBase, &OpenWindowO, &OpenWindowStub },\
{ &LVOSizeWindow, (struct Library *) & IntuitionBase, &SizeWindowO, &SizeWindowStub },\
{ &LVOWindowToBack, (struct Library *) & IntuitionBase, &WindowToBackO, &WindowToBackStub },\
{ &LVOWindowToFront, (struct Library *) & IntuitionBase, &WindowToFrontO, &WindowToFrontStub },\
{ &LVOActivateWindow, (struct Library *) & IntuitionBase, &ActivateWindowO, &ActivateWindowStub },\
{ &LVOMoveWindowInFrontOf, (struct Library *) & IntuitionBase, &MoveWindowInFrontOfO, &MoveWindowInFrontOfStub },\
{ &LVOChangeWindowBox, (struct Library *) & IntuitionBase, &ChangeWindowBoxO, &ChangeWindowBoxStub },\
{ &LVOZipWindow, (struct Library *) & IntuitionBase, &ZipWindowO, &ZipWindowStub },\
{ &LVOOpenWindowTagList, (struct Library *) & IntuitionBase, &OpenWindowTagListO, &OpenWindowTagListStub }

#define WE_CloseWindow		0x0
#define WE_MoveWindow	 	0x1
#define WE_OpenWindow	 	0x2
#define WE_SizeWindow	 	0x3
#define WE_WindowToBack		0x4
#define WE_WindowToFront	0x5
#define WE_ActivateWindow	0x6
#define WE_MoveWindowInFrontOf	0x7
#define WE_ChangeWindowBox	0x8
#define WE_ZipWindow		0x9
#define WE_OpenWindowTagList	0xA

#define WINDOW_EVENTS \
WE_CloseWindow, WE_MoveWindow, WE_OpenWindow, WE_SizeWindow,\
WE_WindowToBack, WE_WindowToFront, WE_ActivateWindow,\
WE_MoveWindowInFrontOf, WE_ChangeWindowBox, WE_ZipWindow, WE_OpenWindowTagList

int start_window_monitor (void);
void stop_window_monitor (void);
void __saveds monitor_event (int event);
